# -*- coding: utf_8 -*-
# 表名: trigger_tag
# 作者: 陈磊
# 时间: 2019-11-13


from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy import Column, Integer, VARCHAR, BIGINT, SMALLINT, DATETIME, DECIMAL, BigInteger, FLOAT, NUMERIC, TEXT
from sqlalchemy.orm.exc import MultipleResultsFound, NoResultFound
from sqlalchemy import or_

from WorkUtils.UtilsLog import UtilsLog
from WorkUtils.UtilsDataBase import UtilsDataBase

import time

Base = declarative_base()


class TriggerTag(Base):
    """
    触发器标签关系表
    """
    __tablename__ = "trigger_tag"

    triggertagid = Column(BigInteger, primary_key=True)
    triggerid = Column(BigInteger)
    tag = Column(VARCHAR(255))
    value = Column(VARCHAR(255))


class DataTriggerTag(object):
    def __init__(self):
        self.log = UtilsLog()
        self.log.info(self.__class__)

        self.table = TriggerTag

    def select_all_from_allKeys(self, session, triggerid=None):
        """
        :param session: 指针
        :param triggerid:
        :return: 查询结果
        """
        self.log.debug("查询数据库:")
        try:
            base = UtilsDataBase()
            base.add_param(_key="triggerid", value=triggerid)
            sql_rep = session.query(self.table).filter_by(**base.param).all()
            self.log.debug(sql_rep)
            session.close()
            return sql_rep
        except UtilsDataBase().errors as error:
            self.log.error("异常:")
            self.log.error(error)
            session.close()
            return error
